/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.ControleRecord;

import java.sql.Date;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Controle extends TableImpl<ControleRecord> {

    private static final long serialVersionUID = -1662142676;

    /**
     * The reference instance of <code>public.controle</code>
     */
    public static final Controle CONTROLE = new Controle();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<ControleRecord> getRecordType() {
        return ControleRecord.class;
    }

    /**
     * The column <code>public.controle.conid</code>.
     */
    public final TableField<ControleRecord, Integer> CONID = createField("conid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('controle_conid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.controle.concriacao</code>.
     */
    public final TableField<ControleRecord, Date> CONCRIACAO = createField("concriacao", org.jooq.impl.SQLDataType.DATE.defaultValue(org.jooq.impl.DSL.field("CURRENT_DATE", org.jooq.impl.SQLDataType.DATE)), this, "");

    /**
     * Create a <code>public.controle</code> table reference
     */
    public Controle() {
        this(DSL.name("controle"), null);
    }

    /**
     * Create an aliased <code>public.controle</code> table reference
     */
    public Controle(String alias) {
        this(DSL.name(alias), CONTROLE);
    }

    /**
     * Create an aliased <code>public.controle</code> table reference
     */
    public Controle(Name alias) {
        this(alias, CONTROLE);
    }

    private Controle(Name alias, Table<ControleRecord> aliased) {
        this(alias, aliased, null);
    }

    private Controle(Name alias, Table<ControleRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.CONTROLE_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<ControleRecord, Integer> getIdentity() {
        return Keys.IDENTITY_CONTROLE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<ControleRecord> getPrimaryKey() {
        return Keys.CONTROLE_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<ControleRecord>> getKeys() {
        return Arrays.<UniqueKey<ControleRecord>>asList(Keys.CONTROLE_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Controle as(String alias) {
        return new Controle(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Controle as(Name alias) {
        return new Controle(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Controle rename(String name) {
        return new Controle(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Controle rename(Name name) {
        return new Controle(name, null);
    }
}
